<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { computed } from 'vue';
import { useCreateStore } from '@/stores/create';
import Button from '@/components/general/Button.vue';
import PreviewLine from '@/components/Create/PreviewLine.vue';

const { t } = useI18n();
const $t = t;

const createStore = useCreateStore();
const { backgroundColor, elementShape, fontSize, likeIcon, allowLikes, elementColor, commentColor, type, lineColor, arrowEnding, lineSize, lineStyle, lineText, activePage, font, allowComments } = storeToRefs(createStore);

const setActivePage = () => {
    activePage.value = type.value === 'Freeform' ? 'line' : 'color';
}

const elementsLabel = $t('general.variables.post.pl');
const commentsLabel = $t('general.variables.comment.pl');

const getFontFamily = computed(() => {
    let localFont;
    switch (font.value) {
        case ('arial'):
            localFont = "Arial, sans-serif";
            break;
        case ('comic-neue'):
            localFont = "'Comic Neue', serif";
            break;
        case ('courier'):
            localFont = "'Courier New', Courier, monospace";
            break;
        case ('times-new-roman'):
            localFont = "'Times New Roman', 'Times New Roman', Times, serif";
            break;
        case ('georgia'):
            localFont = "Georgia, serif";
            break;
        case ('trebuchet-ms'):
            localFont = "'Trebuchet MS', sans-serif";
            break;
        case ('helvetica'):
            localFont = "Helvetica, sans-serif";
            break;
        case ('verdana'):
            localFont = "Verdana, sans-serif";
            break;
        default:
            localFont = '';
            break;
    }
    return localFont;
});

</script>
<template>
    <div class="flex flex-col justify-between h-full">
        <div class="flex flex-row w-full">
            <div class="sm:w-3/5">
                <div class="px-4" v-if="type === 'Freeform'">
                    <h5 class="text-center mb-4 text-lg">{{ elementsLabel }}</h5>
                    <div :class="['w-full relative border-box transition duration-100 ease-in-out rounded-lg p-4 flex flex-col justify-between h-[250px] max-h[250px]', font]"
                        :style="{ background: backgroundColor }">
                        <div class="h-20 w-40 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg flex flex-col justify-between"
                            :class="[elementShape, fontSize]" :style="{ background: elementColor }" id="leftBox">
                            <span>{{ $t('placeholder.text') }}</span>
                            <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                <i class="ri-discuss-line ri-1x" v-show="allowComments"></i>
                                <i class="ri-arrow-right-line ri-1x ml-auto"></i>
                            </div>
                        </div>
                        <div class="h-20 w-40 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg flex flex-col justify-between self-end"
                            :class="[elementShape, fontSize]" :style="{ background: elementColor }" id="rightBox">
                            <span>{{ $t('placeholder.text') }}</span>
                            <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                <i class="ri-discuss-line ri-1x" v-show="allowComments"></i>
                                <i class="ri-arrow-right-line ri-1x ml-auto"></i>
                            </div>
                        </div>
                        <PreviewLine startId="leftBox" endId="rightBox" :color="lineColor" :size="lineSize" :dash="lineStyle==='dotted'?true:false" :ending="arrowEnding" :lineText="lineText" :fontFamily="getFontFamily"/>
                    </div>
                </div>
                <div class="px-4" v-else-if="(type === 'Schedule' || type === 'Stream')">
                    <h5 class="text-center mb-4 text-xl">{{ elementsLabel }}</h5>
                    <div :class="['w-full relative box-border transition duration-100 ease-in-out rounded-lg p-4 h-[250px] max-h-[250px] px-2.5', font]"
                        :style="{ background: backgroundColor }">
                        <div class="flex flex-row gap-2">
                            <div :class="(type === 'Schedule' ? 'w-1/2' : 'w-1/2')">
                                <div class="w-full h-12 p-4 border border-black text-gray-500 rounded-lg"
                                    :class="[elementShape, fontSize]" :style="{ background: elementColor }">
                                    <span>{{ $t('example.column') }}</span>
                                </div>
                                <div class="w-full h-20 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg mt-4 flex flex-col justify-between"
                                    :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                                    <span>{{ $t('example.element') }}</span>
                                    <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                        <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                                        <i class="ri-discuss-line ri-1x ml-auto" v-show="allowComments"></i>
                                    </div>
                                </div>
                                <div class="w-full h-20 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg mt-4 flex flex-col justify-between"
                                    :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                                    <span>{{ $t('example.element') }}</span>
                                    <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                        <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                                        <i class="ri-discuss-line ri-1x ml-auto" v-show="allowComments"></i>
                                    </div>
                                </div>
                            </div>
                            <div class="w-1/2" v-if="type === 'Schedule'">
                                <div class="w-full h-12 p-4 border border-black text-gray-500 rounded-lg"
                                    :class="[elementShape, fontSize]"
                                    :style="{ background: elementColor, paddingTop: '10px' }">
                                    <span>{{ $t('example.column') }}</span>
                                </div>
                                <div class="w-full h-20 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg mt-4 flex flex-col justify-between"
                                    :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                                    <span>{{ $t('example.element') }}</span>
                                    <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                        <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                                        <i class="ri-discuss-line ri-1x ml-auto" v-show="allowComments"></i>
                                    </div>
                                </div>
                                <div class="w-full h-20 border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg mt-4 flex flex-col justify-between"
                                    :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                                    <span>{{ $t('example.element') }}</span>
                                    <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                        <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                                        <i class="ri-discuss-line ri-1x ml-auto" v-show="allowComments"></i>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="px-4" v-else>
                    <h5 class="text-center mb-4 text-xl">{{ elementsLabel }}</h5>
                    <div class="w-full border border-black text-gray-500 p-4 relative box-border transition duration-100 ease-in-out rounded-lg mt-8"
                        :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                        <span>{{ $t('example.element') }}</span>
                        <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                            <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                            <i class="ri-discuss-line ri-1x ml-auto" v-show="allowComments"></i>
                        </div>
                    </div>
                </div>
            </div>
            <div class="sm:w-2/5">
                <div class="px-4">
                    <h5 class="text-center mb-4 text-xl">{{ commentsLabel }}</h5>
                    <div :class="['w-full bg-gray-900 relative box-border transition duration-100 ease-in-out rounded-lg h-[250px] max-h-[250px] p-4 flex flex-col gap-4', font]">
                        <div class="p-4 relative box-border transition duration-100 ease-in-out rounded-lg flex flex-col w-full"
                            :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                            <span> {{ $t('general.variables.comment.sg') }}</span>                           
                            <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                            </div>
                        </div>
                        <div class="p-4 relative box-border transition duration-100 ease-in-out rounded-lg flex flex-col w-full"
                            :class="[elementShape, fontSize]" :style="{ background: commentColor }">
                            <span>{{ $t('general.variables.comment.sg') }}</span>
                            <div class="flex flex-row text-[20px] -ml-2 -mr-2 -mb-4">
                                <i :class="[`ri-${likeIcon}-line ri-1x`]" v-show="allowLikes"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="flex flex-row w-full justify-between">
            <div>
                <Button variant="cancel" @click="setActivePage">
                    <i class="ri-arrow-left-s-line"></i>
                    <span class="uppercase">{{ $t('general.buttons.back') }}</span>
                </Button>
            </div>
        </div>
    </div>
</template>